<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='Logger Example' :maxState='0')
  template(v-slot:description)
    h5 This is a Logger example
    p
      | This set of components and classes are used to log and display errors.
    p Click on the #[em report] to display the error report.
    p Click on the #[em error] to add an error.
    p Click on the #[em warning] to add a warning.
    .d-flex.justify-content-end
      button.mx-1.btn.btn-sm.btn-info(@click='showInterface = !showInterface') interface
      button.mx-1.btn.btn-sm.btn-primary(@click='showReport()') report
      button.mx-1.btn.btn-sm.btn-primary(@click='addError()') error
      button.mx-1.btn.btn-sm.btn-primary(@click='addWarning()') warning
      button.mx-1.btn.btn-sm.btn-primary(@click='addServerError()') server error
    ErrorReport(ref="report")
  li(v-show='showInterface' key='x1')
    div.mt-2
      | #[strong BaseErrorReport:] This modal widget should be added to the
      | main page body, whenever toggled it will display recorded errors.

    div.mt-2
      | #[strong BaseErrorAlert:] This component will display a temporary
      | alert when an error occurs, it should be added to the
      | main page body.
    div.ml-2 #[strong Properties:]
      ul
        +prop("timeout") the error display time
        +prop("maxErrors") maximum number of errors displayed
    div.mt-2
      | #[strong BaseLogger:] This object is an #[span.text-info EventEmitter] that emits 'error' signals.
    ul
      li to emit an error: #[span.text-info BaseLogger.error(myError)]
      li to emit a warning: #[span.text-info BaseLogger.warning(myError)]
      li to clear recorded errors: #[span.text-info BaseLogger.clear()]
      li to get current error list: #[span.text-info BaseLogger.getErrors()]
</template>
<script>
import {
  BaseAnimationGroup as AnimGroup,
  CodeMirrorEditor,
  BaseErrorAlert as ErrorAlert,
  BaseErrorReport as ErrorReport,
  BaseLogger as Logger } from "../src";
import axios from "axios";
import StateComponent from "./AppStateComponent";
import Example from "./AppExample.vue";

export default {
  name: "ExampleLogger",
  components: {
    Example, StateComponent, AnimGroup, CodeMirrorEditor,
    ErrorAlert, ErrorReport
  },
  data() {
    return {
      showCode: false,
      showInterface: false
    };
  },
  watch: {
    showCode() {
      this.$nextTick(() => this.$refs.compCode.refresh());
    }
  },
  methods: {
    showReport() {
      this.$refs.report.toggle();
    },
    addError() {
      Logger.error(new Error("sample error"));
    },
    addWarning() {
      Logger.warning("this is a warning");
    },
    addServerError() {
      axios.get(this.$butils.currentUrl() + "/error_url")
      .catch((err) => Logger.error(err));
    }
  }
};

</script>
<style>
.x-comp-code .CodeMirror {
  height: auto;
}
/* .x-comp-code .CodeMirror-scroll {
  max-height: 20em;
} */
</style>
